-- if things seem odd you can adjust here

-- scale of action bars
local SCALE = 0.78125 -- 0.5 / 0.64

-- height of exp and rep bars
local HEIGHT = 4

-- end of config



do
	-- from MainMenuBarArtFrame that will be hidden
	for i=1, NUM_ACTIONBAR_BUTTONS do
		_G["ActionButton" .. i]:SetParent(MainMenuBar)
	end

	-- hide/show ActionButtons if BonusActionBarFrame is shown/hidden
	local BonusActionBarFrame_OnShow = BonusActionBarFrame:GetScript("OnShow")
	BonusActionBarFrame:SetScript("OnShow", function(...)
		for i=1, NUM_ACTIONBAR_BUTTONS do
			_G["ActionButton" .. i]:SetAlpha(0)
		end
		return BonusActionBarFrame_OnShow and BonusActionBarFrame_OnShow(...)
	end)
	local BonusActionBarFrame_OnHide = BonusActionBarFrame:GetScript("OnHide")
	BonusActionBarFrame:SetScript("OnHide", function(...)
		for i=1, NUM_ACTIONBAR_BUTTONS do
			_G["ActionButton" .. i]:SetAlpha(1)
		end
		return BonusActionBarFrame_OnHide and BonusActionBarFrame_OnHide(...)
	end)

	-- two rows MultiBarBottomRight
	MultiBarBottomRightButton1:ClearAllPoints()
	MultiBarBottomRightButton1:SetPoint("BOTTOMLEFT", MultiBarBottomLeftButton12, "BOTTOMRIGHT", 17, 0)
	MultiBarBottomRightButton7:ClearAllPoints()
	MultiBarBottomRightButton7:SetPoint("BOTTOMLEFT", ActionButton12, "BOTTOMRIGHT", 17, 0)

	-- adjusts MultiBarRight and MultiBarLeft
	-- MultiBarRightButton1:ClearAllPoints()
	-- MultiBarRightButton1:SetPoint("TOPRIGHT", MultiBarRight, x, y)
	-- MultiBarLeftButton1:ClearAllPoints()
	-- MultiBarLeftButton1:SetPoint("TOPRIGHT", MultiBarLeft, x, y)

	-- PetActionButtons on the right side
	PetActionButton1:ClearAllPoints()
	PetActionButton1:SetPoint("BOTTOM", PetActionBarFrame, 0, 2)
	PetActionButton1:SetPoint("LEFT", MultiBarBottomRightButton6, "RIGHT", -404, 0) -- 372 + 32


	-- concerned things with MainMenuBar
	MainMenuExpBar:SetWidth(761)
	MainMenuExpBar:SetHeight(HEIGHT)
	MainMenuExpBar:ClearAllPoints()
	MainMenuExpBar:SetPoint("CENTER", MainMenuBar, "TOP", 0, -4.5)

	local fontFile, fontHeight, fontFlags = MainMenuBarExpText:GetFont()
	MainMenuBarExpText:SetFont(fontFile, floor(fontHeight / SCALE + 0.5), fontFlags)

	ExhaustionLevelFillBar:SetHeight(HEIGHT)

	ReputationWatchBar:SetWidth(761)
	ReputationWatchBar:SetHeight(HEIGHT)

	ReputationWatchStatusBar:SetWidth(761)

	local fontFile, fontHeight, fontFlags = ReputationWatchStatusBarText:GetFont()
	ReputationWatchStatusBarText:SetFont(fontFile, floor(fontHeight / SCALE + 0.5), fontFlags)

	-- re-reconfigure ReputationWatchBar
	-- we can't use events because of the delay issue
	local function ReputationWatchBar_Update_posthook(...)
		local name, reaction, _, _, value = GetWatchedFactionInfo()
		local hasExpBar = MainMenuExpBar:IsShown()

		if ( not name ) then
			if ( hasExpBar and MainMenuBarExpText:GetPoint() ~= "CENTER" ) then
				MainMenuBarExpText:ClearAllPoints()
				MainMenuBarExpText:SetPoint("CENTER", MainMenuExpBar, 0, 1)
			end

			return ...
		end

		ReputationWatchStatusBar:SetHeight(HEIGHT)
		ReputationWatchStatusBarText:SetText(ReputationWatchStatusBarText:GetText() .. " " .. GetText("FACTION_STANDING_LABEL" .. reaction, UnitSex("player"))) -- adds standing label

		if ( hasExpBar ) then
			ReputationWatchBar:ClearAllPoints()
			ReputationWatchBar:SetPoint("CENTER", MainMenuBar, "TOP", 0, 4.5)

			if ( ReputationWatchStatusBarText:GetPoint() ~= "RIGHT" ) then
				ReputationWatchStatusBarText:ClearAllPoints()
				ReputationWatchStatusBarText:SetPoint("RIGHT", ReputationWatchBarOverlayFrame, -128, 1)
			end

			if ( MainMenuBarExpText:GetPoint() ~= "LEFT" ) then
				MainMenuBarExpText:ClearAllPoints()
				MainMenuBarExpText:SetPoint("LEFT", MainMenuExpBar, 128, 1)
			end
		else
			ReputationWatchBar:ClearAllPoints()
			ReputationWatchBar:SetPoint("CENTER", MainMenuBar, "TOP", 0, -4.5)

			if ( ReputationWatchStatusBarText:GetPoint() ~= "CENTER" ) then
				ReputationWatchStatusBarText:ClearAllPoints()
				ReputationWatchStatusBarText:SetPoint("CENTER", ReputationWatchBarOverlayFrame, 0, 1)
			end
		end

		-- removes watched faction if we ware exalted
		if ( value == 42999 ) then
			SetWatchedFactionIndex(0)
		end

		return ...
	end
	local ReputationWatchBar_Update_original = ReputationWatchBar_Update
	function ReputationWatchBar_Update(...)
		return ReputationWatchBar_Update_posthook(ReputationWatchBar_Update_original(...))
	end

	-- actual new MainMenuBar's width
	MainMenuBar:SetWidth(777) -- 761 + 8 * 2
	-- who cares? but i do
	MainMenuBar:EnableMouse(false)


	-- adjusts VehicleMenuBarActionButtons
	VehicleMenuBarActionButton1:ClearAllPoints()
	VehicleMenuBarActionButton1:SetPoint("BOTTOMLEFT", VehicleMenuBarActionButtonFrame, 80, 0)

	-- from VehicleMenuBarArtFrame that will be hidden
	VehicleMenuBarHealthBar:SetParent(VehicleMenuBar)
	VehicleMenuBarPowerBar:SetParent(VehicleMenuBar)


	-- unloads un-wanted textures
	for _, texture in next, {
		MainMenuXPBarTexture0, MainMenuXPBarTexture1, MainMenuXPBarTexture2, MainMenuXPBarTexture3, MainMenuMaxLevelBar0, MainMenuMaxLevelBar1, MainMenuMaxLevelBar2, MainMenuMaxLevelBar3, MainMenuBarTexture0, MainMenuBarTexture1, --[[MainMenuBarTexture2, MainMenuBarTexture3,]] MainMenuBarLeftEndCap, MainMenuBarRightEndCap,
		ReputationWatchBarTexture0, ReputationWatchBarTexture1, ReputationWatchBarTexture2, ReputationWatchBarTexture3, ReputationXPBarTexture0, ReputationXPBarTexture1, ReputationXPBarTexture2, ReputationXPBarTexture3,
		BonusActionBarTexture0, BonusActionBarTexture1, ShapeshiftBarLeft, ShapeshiftBarMiddle, ShapeshiftBarRight, PossessBackground1, PossessBackground2,
		SlidingActionBarTexture0, SlidingActionBarTexture1,
	} do
		texture:SetTexture(nil)
	end

	-- scales these bars
	for _, bar in next, {
		MainMenuBar, VehicleMenuBar, MultiBarBottomLeft, MultiBarBottomRight, MultiBarRight, MultiBarLeft,
	} do
		bar:SetScale(SCALE)
	end

	-- hides these artworks
	MainMenuBarArtFrame:Hide()
	VehicleMenuBarArtFrame:Hide()

	-- disables frame management
	-- UIPARENT_MANAGED_FRAME_POSITIONS["MultiBarBottomLeft"] = nil
	UIPARENT_MANAGED_FRAME_POSITIONS["MultiBarRight"] = nil
	-- UIPARENT_MANAGED_FRAME_POSITIONS["VoiceChatTalkers"] = nil
	-- UIPARENT_MANAGED_FRAME_POSITIONS["GroupLootFrame1"] = nil
	-- UIPARENT_MANAGED_FRAME_POSITIONS["TutorialFrameParent"] = nil
	-- UIPARENT_MANAGED_FRAME_POSITIONS["FramerateLabel"] = nil
	-- UIPARENT_MANAGED_FRAME_POSITIONS["CastingBarFrame"] = nil
	-- UIPARENT_MANAGED_FRAME_POSITIONS["ChatFrame1"] = nil
	-- UIPARENT_MANAGED_FRAME_POSITIONS["ChatFrame2"] = nil
	-- UIPARENT_MANAGED_FRAME_POSITIONS["ShapeshiftBarFrame"] = nil
	-- UIPARENT_MANAGED_FRAME_POSITIONS["PossessBarFrame"] = nil

	-- UIPARENT_MANAGED_FRAME_POSITIONS["CONTAINER_OFFSET_X"] = nil
	UIPARENT_MANAGED_FRAME_POSITIONS["CONTAINER_OFFSET_Y"] = nil
	UIPARENT_MANAGED_FRAME_POSITIONS["BATTLEFIELD_TAB_OFFSET_Y"] = nil
	-- UIPARENT_MANAGED_FRAME_POSITIONS["PETACTIONBAR_YPOS"] = nil
end



-- extras. you can delete them safely

-- cheap auto ReputationWatchBar
local f, faction = CreateFrame("Frame")
f:SetScript("OnEvent", function(self, event, message)
	faction = message and strmatch(message, "Reputation with (.+) increased by")
	if ( faction and faction ~= GetWatchedFactionInfo() ) then
		for i=1, GetNumFactions() do
			if ( faction == GetFactionInfo(i) ) then
				SetWatchedFactionIndex(i)
				break
			end
		end
	end
end)
f:RegisterEvent("CHAT_MSG_COMBAT_FACTION_CHANGE")


-- show/hide MainMenuBarMicroButtons under ContainerFrame if ContainerFrame was shown/hidden
do
	local micros = { CharacterMicroButton, SpellbookMicroButton, TalentMicroButton, AchievementMicroButton, QuestLogMicroButton, SocialsMicroButton, PVPMicroButton, LFDMicroButton, MainMenuMicroButton, HelpMicroButton, }
	local function vehicleMenuBar_MoveMicroButtons()
		for _, button in next, micros do
			button:SetParent(ContainerFrame1)
		end
		CharacterMicroButton:ClearAllPoints()
		CharacterMicroButton:SetPoint("BOTTOM", UIParent, 0, 4)
		CharacterMicroButton:SetPoint("LEFT", ContainerFrame1MoneyFrame, "RIGHT", -213, 0) -- 22.4 * 10 - 3 * 9 + 16
		SocialsMicroButton:ClearAllPoints()
		SocialsMicroButton:SetPoint("BOTTOMLEFT", QuestLogMicroButton, "BOTTOMRIGHT", -3, 0)
	end
	hooksecurefunc("VehicleMenuBar_MoveMicroButtons", vehicleMenuBar_MoveMicroButtons)
	for _, button in next, micros do
		button:SetWidth(22.4) -- fits with MainMenuBarBagButtons' width
		button:SetScale(SCALE)
	end
	vehicleMenuBar_MoveMicroButtons()
end


-- show/hide MainMenuBarBagButtons under ContainerFrame if ContainerFrame was shown/hidden
for _, button in next, { MainMenuBarBackpackButton, CharacterBag0Slot, CharacterBag1Slot, CharacterBag2Slot, CharacterBag3Slot, KeyRingButton } do
	button:SetParent(ContainerFrame1)
	button:SetScale(SCALE)
	_G[button:GetName() .. "ItemAnim"]:UnregisterEvent("ITEM_PUSH") -- disables loot animation
end
MainMenuBarBackpackButton:ClearAllPoints()
MainMenuBarBackpackButton:SetPoint("BOTTOM", UIParent, 0, 57) -- 4 + 36 + 17
MainMenuBarBackpackButton:SetPoint("RIGHT", ContainerFrame1MoneyFrame, -16, 0)
